#include <windows.h>
#include <commctrl.h>
#include <math.h>
#include <vector>

using namespace std;


#include "aeffeditor.h"



#define GUI_WINDOW_WDT		595
#define GUI_WINDOW_HGT		255

#define GUI_COLOR_ERROR		RGB(255,255,128)

enum {
	IDC_BUTTON_PULSE=1000,
	IDC_BUTTON_TRIANGLE,
	IDC_BUTTON_NOISE,
	IDC_BUTTON_MULTI,
	IDC_BUTTON_NTSC,
	IDC_BUTTON_PAL,
	IDC_TRACKBAR_GAIN,
	IDC_LABEL_MIDI,
	IDC_BUTTON_MIDI_UP,
	IDC_BUTTON_MIDI_DOWN,
	IDC_LABEL_POLY,
	IDC_BUTTON_POLY_UP,
	IDC_BUTTON_POLY_DOWN,
	IDC_LABEL_ERROR,
};



class GUI:public AEffEditor
{
	FTPLUG *ftplug;

private:

	char ClassName[32];

	HWND hWndForm;
	HWND hWndLabelV;
	HWND hWndLabelA;
	HWND hWndLabelP;
	HWND hWndLabelH;
	HWND hWndLabelD;
	HWND hWndEditV;
	HWND hWndEditA;
	HWND hWndEditP;
	HWND hWndEditH;
	HWND hWndEditD;
	HWND hWndButtonPulse;
	HWND hWndButtonTri;
	HWND hWndButtonNoise;
	HWND hWndButtonNTSC;
	HWND hWndButtonPAL;
	HWND hWndButtonMultiMode;
	HWND hWndLabelMIDI;
	HWND hWndLabelPoly;
	HWND hWndButtonMIDIUp;
	HWND hWndButtonMIDIDown;
	HWND hWndButtonPolyUp;
	HWND hWndButtonPolyDown;
	HWND hWndLabelError;
	HWND hWndTrackGain;

	ERect rect;

	const char* GetClassName(void);
	const char* CompileErrorText;

	static LONG WINAPI WndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);

	bool NeedUpdate;
	bool NeedUpdateEdits;

public:

	GUI(AudioEffect* effect);

	~GUI();

	virtual bool open(void* ptr);

	virtual void close();

	virtual void idle();

	virtual bool getRect(ERect **ppRect);

	void SetUpdate(bool program);
};
